DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Protected Member Functions | Private Member Functions | List of all members
DiFlipTemplate< T > Class Template Reference

Template class to flip images (on pixel data level). More...

Inheritance diagram for DiFlipTemplate< T >:

## Public Member Functions
| DiFlipTemplate (DiPixel *pixel, const Uint16 columns, const Uint16 rows, const Uint32 frames, const int horz, const int vert)
| constructor. More...
| DiFlipTemplate (const int planes, const Uint16 columns, const Uint16 rows, const Uint32 frames)
| constructor. More...
virtual | ~DiFlipTemplate ()
| destructor
void | flipData (const T *src[], T *dest[], const int horz, const int vert)
| choose algorithm depending on flipping mode More...

## Protected Member Functions
void | flipHorz (const T *src[], T *dest[])
| flip source image horizontally and store result in destination image More...
void | flipVert (const T *src[], T *dest[])
| flip source image vertically and store result in destination image More...
void | flipHorzVert (const T *src[], T *dest[])
| flip source image horizontally and vertically and store result in destination image More...
Protected Member Functions inherited from DiTransTemplate< T >
| DiTransTemplate (const int planes, const Uint16 src_x, const Uint16 src_y, const Uint16 dest_x, const Uint16 dest_y, const Uint32 frames, const int bits=0)
| constructor More...
virtual | ~DiTransTemplate ()
| destructor
void | copyPixel (const T *src[], T *dest[])
| copy pixel data More...
void | fillPixel (T *dest[], const T value)
| fill pixel data with specified value More...
void | clearPixel (T *dest[])
| clear pixel data (set values to 0) More...

## Private Member Functions
void | flipHorz (T *data[])
| flip image horizontally and store result in the same storage area More...
void | flipVert (T *data[])
| flip image vertically and store result in the same storage area More...
void | flipHorzVert (T *data[])
| flip image horizontally and vertically and store result in the same storage area More...

## Additional Inherited Members
Protected Attributes inherited from DiTransTemplate< T >
int | Planes
| number of planes
Uint16 | Src_X
| width of source image
Uint16 | Src_Y
| height of source image
const Uint16 | Dest_X
| width of destination image
const Uint16 | Dest_Y
| height of destination image
const Uint32 | Frames
| number of frames
const int | Bits
| number of bits per plane/pixel

## Detailed Description

### template<class T>
class DiFlipTemplate< T >

Template class to flip images (on pixel data level).

horizontally and vertically

## Constructor & Destructor Documentation

## ◆ DiFlipTemplate() [1/2]

template<class T >

DiFlipTemplate< T >::DiFlipTemplate | ( | DiPixel * | pixel,
|  | const Uint16 | columns,
|  | const Uint16 | rows,
|  | const Uint32 | frames,
|  | const int | horz,
|  | const int | vert
| ) |  |
| inline

constructor.

This method is used to flip an image and store the result in the same storage area.

Parameters

  pixel | pointer to object where the pixel data are stored
  columns | width of the image
  rows | height of the image
  frames | number of frames
  horz | flags indicating whether to flip horizontally or not
  vert | flags indicating whether to flip vertically or not

References DiPixel::getCount(), DiPixel::getPlanes(), and DiTransTemplate< T >::Planes.

## ◆ DiFlipTemplate() [2/2]

template<class T >

DiFlipTemplate< T >::DiFlipTemplate | ( | const int | planes,
|  | const Uint16 | columns,
|  | const Uint16 | rows,
|  | const Uint32 | frames
| ) |  |
| inline

constructor.

This method is used to perform only the preparation and to start flipping later with method 'flipData()'

Parameters

  planes | number of planes (1 or 3)
  columns | width of the image
  rows | height of the image
  frames | number of frames

## Member Function Documentation

## ◆ flipData()

template<class T >

void DiFlipTemplate< T >::flipData | ( | const T * | src[],
|  | T * | dest[],
|  | const int | horz,
|  | const int | vert
| ) |  |
| inline

choose algorithm depending on flipping mode

Parameters

  src | array of pointers to source image pixels
  dest | array of pointers to destination image pixels
  horz | flags indicating whether to flip horizontally or not
  vert | flags indicating whether to flip vertically or not

References DiTransTemplate< T >::copyPixel(), DiFlipTemplate< T >::flipHorz(), DiFlipTemplate< T >::flipHorzVert(), and DiFlipTemplate< T >::flipVert().

## ◆ flipHorz() [1/2]

template<class T >

void DiFlipTemplate< T >::flipHorz | ( | const T * | src[],
|  | T * | dest[]
| ) |  |
| inline protected

flip source image horizontally and store result in destination image

Parameters

  src | array of pointers to source image pixels
  dest | array of pointers to destination image pixels

References DiTransTemplate< T >::Dest_X, DiTransTemplate< T >::Frames, DiTransTemplate< T >::Planes, DiTransTemplate< T >::Src_X, and DiTransTemplate< T >::Src_Y.

Referenced by DiMonoFlipTemplate< T >::flip(), DiColorFlipTemplate< T >::flip(), and DiFlipTemplate< T >::flipData().

## ◆ flipHorz() [2/2]

template<class T >

void DiFlipTemplate< T >::flipHorz | ( | T * | data[] | ) |
| inline private

flip image horizontally and store result in the same storage area

Parameters

  data | array of pointers to source/destination image pixels

References DiTransTemplate< T >::Dest_X, DiTransTemplate< T >::Frames, DiTransTemplate< T >::Planes, DiTransTemplate< T >::Src_X, and DiTransTemplate< T >::Src_Y.

## ◆ flipHorzVert() [1/2]

template<class T >

void DiFlipTemplate< T >::flipHorzVert | ( | const T * | src[],
|  | T * | dest[]
| ) |  |
| inline protected

flip source image horizontally and vertically and store result in destination image

Parameters

  src | array of pointers to source image pixels
  dest | array of pointers to destination image pixels

Referenced by DiMonoFlipTemplate< T >::flip(), DiColorFlipTemplate< T >::flip(), and DiFlipTemplate< T >::flipData().

## ◆ flipHorzVert() [2/2]

template<class T >

void DiFlipTemplate< T >::flipHorzVert | ( | T * | data[] | ) |
| inline private

flip image horizontally and vertically and store result in the same storage area

Parameters

  data | array of pointers to source/destination image pixels

## ◆ flipVert() [1/2]

template<class T >

void DiFlipTemplate< T >::flipVert | ( | const T * | src[],
|  | T * | dest[]
| ) |  |
| inline protected

flip source image vertically and store result in destination image

Parameters

  src | array of pointers to source image pixels
  dest | array of pointers to destination image pixels

Referenced by DiMonoFlipTemplate< T >::flip(), DiColorFlipTemplate< T >::flip(), and DiFlipTemplate< T >::flipData().

## ◆ flipVert() [2/2]

template<class T >

void DiFlipTemplate< T >::flipVert | ( | T * | data[] | ) |
| inline private

flip image vertically and store result in the same storage area

Parameters

  data | array of pointers to source/destination image pixels

The documentation for this class was generated from the following file:

- dcmimgle/include/dcmtk/dcmimgle/diflipt.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1